#!/usr/bin/env ruby

# This is a little script to generate fan-animations, by gradually changing the
# length of one edge-length in a surface.
# The argument "shape" should be the name of a file in test_shapes
# The argument "edge" indicates the *line in that file* on which the edge to be
# modified appears
# The arguments start and en are the range of values that should be taken on,
# times a hundred. So, for example, if an edge should go between .5 and 1.5,
# stard and en should be 50 and 150.
# The increments are always .01

shape, edge, start, en= ARGV

name = "#{shape}_#{edge}_#{start}_#{en}"

Dir.mkdir(name)

start.to_i.upto(en.to_i).map{|i| "%03d" % i}.each do |i|
    a, b = i[0], i[1..2]
    `sed -i '#{edge}s/[^ ]\\+$/#{a}.#{b}/' test_shapes/#{shape}`
    `./fan.py -s test_shapes/#{shape} > #{name}/out#{i}.svg`
    `convert #{name}/out#{i}.svg #{name}/out#{i}.gif`
end

Dir.chdir(name) do
    `gifsicle --colors 256 --loopcount=forever *gif > #{name}.gif`
end
